Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.apache.commons.collections.map
Class LinkedMap

    java.lang.Object
      |
      +--java.util.AbstractMap
            |
            +--org.apache.commons.collections.map.AbstractHashedMap
                  |
                  +--org.apache.commons.collections.map.AbstractLinkedMap
                        |
                        +--org.apache.commons.collections.map.LinkedMap

All Implemented Interfaces:
  Cloneable, IterableMap, Map, OrderedMap, Serializable

public class LinkedMap
extends AbstractLinkedMap
implements Serializable, Cloneable

A `Map` implementation that maintains the order of the entries. In this implementation order is maintained by original insertion.

This implementation improves on the JDK1.4 LinkedHashMap by adding the `MapIterator` functionality, additional convenience methods and allowing bidirectional iteration. It also implements `OrderedMap`. In addition, non-interface methods are provided to access the map by index.

The `orderedMapIterator()` method provides direct access to a bidirectional iterator. The iterators from the other views can also be cast to `OrderedIterator` if required.

All the available iterators can be reset back to the start by casting to `ResettableIterator` and calling `reset()`.

The implementation is also designed to be subclassed, with lots of useful methods exposed.

Since:
  Commons Collections 3.0
Version:
  $Revision: 1.9 $ $Date: 2004/02/18 01:13:19 $
Author:
  Stephen Colebourne
See Also:
  Serialized Form

Nested Class Summary

Nested classes inherited from class org.apache.commons.collections.map.AbstractLinkedMap
`AbstractLinkedMap.EntrySetIterator, AbstractLinkedMap.KeySetIterator, AbstractLinkedMap.LinkEntry, AbstractLinkedMap.LinkIterator, AbstractLinkedMap.LinkMapIterator, AbstractLinkedMap.ValuesIterator`

Nested classes inherited from class org.apache.commons.collections.map.AbstractHashedMap
`AbstractHashedMap.EntrySet, AbstractHashedMap.EntrySetIterator, AbstractHashedMap.HashEntry, AbstractHashedMap.HashIterator, AbstractHashedMap.HashMapIterator, AbstractHashedMap.KeySet, AbstractHashedMap.KeySetIterator, AbstractHashedMap.Values, AbstractHashedMap.ValuesIterator`

Field Summary

Fields inherited from class org.apache.commons.collections.map.AbstractLinkedMap
`header`

Fields inherited from class org.apache.commons.collections.map.AbstractHashedMap
`data, DEFAULT_CAPACITY, DEFAULT_LOAD_FACTOR, DEFAULT_THRESHOLD, entrySet, GETKEY_INVALID, GETVALUE_INVALID, keySet, loadFactor, MAXIMUM_CAPACITY, modCount, NO_NEXT_ENTRY, NO_PREVIOUS_ENTRY, NULL, REMOVE_INVALID, SETVALUE_INVALID, size, threshold, values`

Constructor Summary
`LinkedMap()` Constructs a new empty map with default size and load factor.
`LinkedMap(int initialCapacity)` Constructs a new, empty map with the specified initial capacity.
`LinkedMap(int initialCapacity, float loadFactor)` Constructs a new, empty map with the specified initial capacity and load factor.
`LinkedMap(Map map)` Constructor copying elements from another map.

Method Summary
`List` | `asList()` Gets an unmodifiable List view of the keys.
`Object` | `clone()` Clones the map without cloning the keys or values.
`Object` | `get(int index)` Gets the key at the specified index.
`Object` | `getValue(int index)` Gets the value at the specified index.
`int` | `indexOf(Object key)` Gets the index of the specified key.
`Object` | `remove(int index)` Removes the element at the specified index.

Methods inherited from class org.apache.commons.collections.map.AbstractLinkedMap
`addEntry, clear, containsValue, createEntry, createEntrySetIterator, createKeySetIterator, createValuesIterator, entryAfter, entryBefore, firstKey, getEntry, init, lastKey, mapIterator, nextKey, orderedMapIterator, previousKey, removeEntry`

Methods inherited from class org.apache.commons.collections.map.AbstractHashedMap
`addMapping, calculateNewCapacity, calculateThreshold, checkCapacity, containsKey, convertKey, destroyEntry, doReadObject, doWriteObject, ensureCapacity, entryHashCode, entryKey, entryNext, entrySet, entryValue, equals, get, getEntry, hash, hashCode, hashIndex, isEmpty, isEqualKey, isEqualValue, keySet, put, putAll, remove, removeMapping, reuseEntry, size, toString, updateEntry, values`

Methods inherited from class java.lang.Object
`finalize, getClass, notify, notifyAll, wait, wait, wait`

Methods inherited from interface java.util.Map
`containsKey, entrySet, equals, get, hashCode, isEmpty, keySet, put, putAll, remove, size, values`

Constructor Detail

### LinkedMap

    public LinkedMap()

  Constructs a new empty map with default size and load factor.

### LinkedMap

    public LinkedMap(int initialCapacity)

  Constructs a new, empty map with the specified initial capacity.

Parameters:
  `initialCapacity` - the initial capacity
Throws:
  `IllegalArgumentException` - if the initial capacity is less than one

### LinkedMap

    public LinkedMap(int initialCapacity,
                     float loadFactor)

  Constructs a new, empty map with the specified initial capacity and load factor.

Parameters:
  `initialCapacity` - the initial capacity
  `loadFactor` - the load factor
Throws:
  `IllegalArgumentException` - if the initial capacity is less than one
  `IllegalArgumentException` - if the load factor is less than zero

### LinkedMap

    public LinkedMap(Map map)

  Constructor copying elements from another map.

Parameters:
  `map` - the map to copy
Throws:
  `NullPointerException` - if the map is null

Method Detail

### clone

    public Object clone()

  Clones the map without cloning the keys or values.

  Overrides:
    `clone` in class `AbstractHashedMap`
  Returns:
    a shallow clone

### get

    public Object get(int index)

  Gets the key at the specified index.

  Parameters:
    `index` - the index to retrieve
  Returns:
    the key at the specified index
  Throws:
    `IndexOutOfBoundsException` - if the index is invalid

### getValue

    public Object getValue(int index)

  Gets the value at the specified index.

  Parameters:
    `index` - the index to retrieve
  Returns:
    the key at the specified index
  Throws:
    `IndexOutOfBoundsException` - if the index is invalid

### indexOf

    public int indexOf(Object key)

  Gets the index of the specified key.

  Parameters:
    `key` - the key to find the index of
  Returns:
    the index, or -1 if not found

### remove

    public Object remove(int index)

  Removes the element at the specified index.

  Parameters:
    `index` - the index of the object to remove
  Returns:
    the previous value corresponding the `key`, or `null` if none existed
  Throws:
    `IndexOutOfBoundsException` - if the index is invalid

### asList

    public List asList()

  Gets an unmodifiable List view of the keys.

  The returned list is unmodifiable because changes to the values of the list (using `ListIterator.set(Object)`) will effectively remove the value from the list and reinsert that value at the end of the list, which is an unexpected side effect of changing the value of a list. This occurs because changing the key, changes when the mapping is added to the map and thus where it appears in the list.

  An alternative to this method is to use `AbstractHashedMap.keySet()`.

  Returns:
    The ordered list of keys.
  See Also:
    `AbstractHashedMap.keySet()`

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2001-2004 Apache Software Foundation. All Rights Reserved.